//notes
typedef struct {
	unsigned short mipmap_start;
	unsigned short mipmap_length;
	
	unsigned char sample_overstep_inc;
} note_t;

//buttons
typedef struct {
	unsigned char voice_index;
} key_t;

//voices
typedef struct {
	unsigned short mipmap_start;
	unsigned short mipmap_current;
	unsigned short mipmap_end;
	unsigned short mipmap_length;
	
	unsigned char sample_overstep; // this gets incremented with sample_overstep_inc at every interrupt
	unsigned char sample_overstep_inc; // This also represents the distance between current mipmap and next one. 0 = current, 255 = next
	
	unsigned char env_index;
	unsigned char env_amp_multiplier;
	unsigned char env_amp_release_base;
	
	signed char last_value;
	unsigned char env_lpf_multiplier;
	unsigned char env_lpf_release_scale;
	unsigned char env_lpf_release_target;
	
	unsigned char state;
	unsigned char key_index;
} voice_t;

